=== test/unit/CMakeLists.txt ===
add_executable(queue queue.c)
add_executable(mhash mhash.c)
add_executable(objc_finally objc_finally.m)
add_executable(objc_catchcxx objc_catchcxx.m)
set_target_properties(mhash PROPERTIES COMPILE_FLAGS "-std=c99")
target_link_libraries(objc_finally ${LIBOBJC_LIB})
target_link_libraries(objc_catchcxx ${LIBOBJC_LIB} ${LUAJIT_LIB})
if (TARGET_OS_LINUX OR TARGET_OS_DEBIAN_FREEBSD)
    target_link_libraries(objc_catchcxx dl)
endif()
