=== debian/changelog ===
tarantool (1.4.7+20120714-1) unstable; urgency=low

  * Fixed memcached space and some troubles in build system.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 14 Jul 2012 10:05:37 +0400

tarantool (1.4.7-1) unstable; urgency=low

  * New upstream stable version.
    - can be built by gcc-4.7;
    - new transaction processor;
    - add libtarantoolrpl library (provides replication protocol);
    - extract perl and php drivers to their own repositaries.
    - etc

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 11 Jul 2012 10:06:52 +0400
