## tarantool 1.4.7+20121010.2202

=== debian/changelog ===
tarantool (1.4.7+20121010.2202-1) unstable; urgency=low

  * New snapshot (Don't exit on a trivial socket error).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 10 Oct 2012 22:01:58 +0400

tarantool (1.4.7+20121010-1) unstable; urgency=low

  * New snapshot.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 10 Oct 2012 17:22:26 +0400

tarantool (1.4.7+20120918-1) unstable; urgency=low

  * New snapshot (some fixes in lua:box.slab).

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 18 Sep 2012 21:57:51 +0400

tarantool (1.4.7+20120915-1) unstable; urgency=low

  * New snapshot (enable box.info, box.slab, box.stat, etc)

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 15 Sep 2012 00:02:10 +0400

tarantool (1.4.7+20120905-1) unstable; urgency=low

  * New snapshot.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 05 Sep 2012 15:36:27 +0400

tarantool (1.4.7+20120829-1) unstable; urgency=low

  * New snapshot (some fixes, add box.uuid() and box.uuid_hex() functions).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 29 Aug 2012 16:46:58 +0400

tarantool (1.4.7+20120820-1) unstable; urgency=low

  * New snapshot (fixed tuple:transform crash).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 20 Aug 2012 21:42:21 +0400

tarantool (1.4.7+20120817-1) unstable; urgency=low

  * New upstream version.
   + Add WAL rotate script.
  * Add all contributors to debian/copyright (fix lintian warning).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 03 Aug 2012 12:09:14 +0400
