=== debian/rules ===
--- 
+++ 
@@ -54,5 +54,8 @@
 	pod2man -c 'tarantool log rotation' \
 	    debian/scripts/tarantool_logrotate \
 	    	 > build-area/tarantool_logrotate.1
+	pod2man -c 'snapshot rotate' \
+	    debian/scripts/tarantool_snapshot_rotate \
+	    	> build-area/tarantool_snapshot_rotate.1
 	install -m0755 extra/logger.pl \
 	    debian/tarantool-common/usr/lib/tarantool/logger
