## tarantool 1.4.8+20121207

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,9 @@
 #
 set (TARANTOOL_PRODUCT "box")
 set (TARANTOOL_MODULES "box")
-set (TARANTOOL_CLIENTS "")
+set (TARANTOOL_CLIENTS "tarantool_checksum")
+# Define PACKAGE macro in config.h
+set (PACKAGE "Tarantool")
 
 #
 # Set default build type to Debug. This is to ease a developer's
@@ -79,11 +81,11 @@
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 
 #
-# Define TARANTOOL_VERSION -- a string constant with tarantool version.
-#
-set (TARANTOOL_VERSION "")
+# Define PACKAGE_VERSION -- a string constant with tarantool version.
+#
+set (PACKAGE_VERSION "")
 execute_process (COMMAND ${GIT} describe HEAD
-    OUTPUT_VARIABLE TARANTOOL_VERSION
+    OUTPUT_VARIABLE PACKAGE_VERSION
     OUTPUT_STRIP_TRAILING_WHITESPACE
     )
 #
@@ -92,9 +94,9 @@
 #
 set (CPACK_PACKAGE_VERSION_MAJOR "1")
 set (CPACK_PACKAGE_VERSION_MINOR "4")
-set (CPACK_PACKAGE_VERSION_PATCH "7")
-if (TARANTOOL_VERSION STREQUAL "")
-    set (TARANTOOL_VERSION
+set (CPACK_PACKAGE_VERSION_PATCH "8")
+if (PACKAGE_VERSION STREQUAL "")
+    set (PACKAGE_VERSION
         "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 endif()
 
@@ -158,7 +160,9 @@
     endif()
     # Use GNU bfd if present.
     check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
+    set(CMAKE_REQUIRED_DEFINITIONS -DPACKAGE=${PACKAGE} -DPACKAGE_VERSION=${PACKAGE_VERSION})
     check_include_file(bfd.h HAVE_BFD_H)
+    set(CMAKE_REQUIRED_DEFINITIONS)
     if (HAVE_BFD_LIB AND HAVE_BFD_H)
         set (HAVE_BFD True)
     endif()
@@ -174,7 +178,6 @@
 add_subdirectory(connector)
 add_subdirectory(src)
 add_subdirectory(extra)
-add_subdirectory(mod)
 add_subdirectory(client)
 add_subdirectory(test)
 add_subdirectory(doc)
@@ -182,7 +185,7 @@
 install (FILES README LICENSE doc/box-protocol.txt
          DESTINATION share/doc/tarantool)
 
-include (cmake/tarantool_cpack.cmake)
+include (cmake/cpack.cmake)
 
 # tarantool info summary (used in server version output)
 #
@@ -213,7 +216,7 @@
 message (STATUS "")
 message (STATUS "Tarantool configuration is complete:")
 message (STATUS "")
-message (STATUS "VERSION: ${TARANTOOL_VERSION}")
+message (STATUS "VERSION: ${PACKAGE_VERSION}")
 message (STATUS "BUILD: ${TARANTOOL_BUILD}")
 message (STATUS "COMPILER: ${TARANTOOL_COMPILER}")
 message (STATUS "CFLAGS:${CMAKE_C_FLAGS} ${core_cflags}")
