## tarantool 1.4.8+20121214

=== debian/changelog ===
tarantool (1.4.8+20121214-1) unstable; urgency=low

  * New snapshot (fix segfault with box.ipc.channel).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 14 Dec 2012 16:39:02 +0400

tarantool (1.4.8+20121207-1) unstable; urgency=low

  * New snapshot (add box.time64 needed by queues).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 07 Dec 2012 14:45:38 +0400

tarantool (1.4.8-1) unstable; urgency=low

  * New tarantool release.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 23 Nov 2012 11:56:02 +0400
